Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.cayenne.map
Class EntityResolver

    java.lang.Object
      org.apache.cayenne.map.EntityResolver

All Implemented Interfaces:
  Serializable, MappingNamespace

    public class EntityResolver

extends Object
implements MappingNamespace, Serializable

Represents a virtual shared namespace for zero or more DataMaps. Unlike DataMap, EntityResolver is intended to work as a runtime container of mapping. DataMaps can be added or removed dynamically at runtime.

EntityResolver is thread-safe.

Since:
  1.1
Author:
  Andrus Adamchik
See Also:
  Serialized Form

Field Summary
`protected LifecycleCallbackRegistry` | `callbackRegistry`
`protected ClassDescriptorMap` | `classDescriptorMap`
`protected EntityResolver` | `clientEntityResolver`
`protected Map` | `dbEntityCache`
`protected Map` | `embeddableCache`
`protected Map` | `entityInheritanceCache`
`protected Map` | `entityListenerCache`
`protected boolean` | `indexedByClass`
`protected static org.apache.commons.logging.Log` | `logger`
`protected List` | `maps`
`protected Map` | `objEntityCache`
`protected Map` | `procedureCache`
`protected Map` | `queryCache`

Constructor Summary
`EntityResolver()` Creates new EntityResolver.
`EntityResolver(Collection dataMaps)` Creates new EntityResolver that indexes a collection of DataMaps.

Method Summary
`protected DbEntity` | `_lookupDbEntity(Object object)` Internal usage only - provides the type-unsafe implementation which services the four typesafe public lookupDbEntity methods Looks in the DataMap's that this object was created with for the ObjEntity that maps to the specified object.
`protected ObjEntity` | `_lookupObjEntity(String key)` Internal usage only - provides the type-unsafe implementation which services the three typesafe public lookupObjEntity methods Looks in the DataMap's that this object was created with for the ObjEntity that maps to the specified object.
`void` | `addDataMap(DataMap map)`
`protected String` | `classKey(String className)` Generates a map key for the object class.
`void` | `clearCache()` Removes all entity mappings from the cache.
`protected void` | `constructCache()` Creates caches of DbEntities by ObjEntity, DataObject class, and ObjEntity name using internal list of maps.
`LifecycleCallbackRegistry` | `getCallbackRegistry()` Returns a `LifecycleCallbackRegistry` for handling callbacks.
`ClassDescriptor` | `getClassDescriptor(String entityName)` Returns ClassDescriptor for the ObjEntity matching the name.
`ClassDescriptorMap` | `getClassDescriptorMap()` Returns an object that compiles and stores `ClassDescriptor` instances for all entities.
`EntityResolver` | `getClientEntityResolver()` Returns ClientEntityResolver with mapping information that only includes entities available on CWS Client Tier.
`DataMap` | `getDataMap(String mapName)` Returns a DataMap matching the name.
`Collection` | `getDataMaps()` Returns an unmodifiable collection of DataMaps.
`Collection` | `getDbEntities()` Returns all DbEntities.
`DbEntity` | `getDbEntity(String name)` Returns DbEntity for a given name, or null if no such DbEntity is found in the MappingNamespace.
`Embeddable` | `getEmbeddable(String className)` Returns an `Embeddable` matching class name or null if such Embeddable is not mapped.
`EntityListener` | `getEntityListener(String className)` Returns an `EntityListener` matching class name or null if such EntityListener is not mapped.
`Collection` | `getObjEntities()` Returns all ObjEntities in the namespace.
`ObjEntity` | `getObjEntity(String name)` Returns ObjEntity for a given name, or null if no such ObjEntity is found in the MappingNamespace.
`Procedure` | `getProcedure(String name)` Returns Procedure for a given name, or null if no such Procedure is found in the MappingNamespace.
`Collection` | `getProcedures()` Returns all Procedures in the namespace.
`Collection` | `getQueries()` Returns all Queries in the namespace.
`Query` | `getQuery(String name)` Returns Query for a given name, or null if no such Query is found in the MappingNamespace.
`boolean` | `isIndexedByClass()`
`DbEntity` | `lookupDbEntity(Class aClass)` Deprecated. since 3.0 - lookup DbEntity via ObjEntity instead.
`DbEntity` | `lookupDbEntity(Persistent dataObject)` Deprecated. since 3.0 - lookup DbEntity via ObjEntity instead.
`EntityInheritanceTree` | `lookupInheritanceTree(ObjEntity entity)` Returns EntityInheritanceTree representing inheritance hierarchy that starts with a given ObjEntity as root, and includes all its subentities.
`ObjEntity` | `lookupObjEntity(Class aClass)` Looks in the DataMap's that this object was created with for the ObjEntity that maps to the services the specified class
`ObjEntity` | `lookupObjEntity(Object object)` Looks in the DataMap's that this object was created with for the ObjEntity that services the specified data Object
`ObjEntity` | `lookupObjEntity(String entityName)` Deprecated. since 3.0 - use getObjEntity() instead.
`Procedure` | `lookupProcedure(Query q)`
`Procedure` | `lookupProcedure(String procedureName)`
`Query` | `lookupQuery(String name)` Returns a named query or null if no query exists for a given name.
`void` | `removeDataMap(DataMap map)`
`void` | `setDataMaps(Collection maps)`
`void` | `setIndexedByClass(boolean b)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected static final org.apache.commons.logging.Log logger

### indexedByClass

    protected boolean indexedByClass

### queryCache

    protected transient Map queryCache

### embeddableCache

    protected transient Map embeddableCache

### entityListenerCache

    protected transient Map entityListenerCache

### dbEntityCache

    protected transient Map dbEntityCache

### objEntityCache

    protected transient Map objEntityCache

### procedureCache

    protected transient Map procedureCache

### maps

    protected List maps

### entityInheritanceCache

    protected transient Map entityInheritanceCache

### clientEntityResolver

    protected EntityResolver clientEntityResolver

### classDescriptorMap

    protected transient ClassDescriptorMap classDescriptorMap

### callbackRegistry

    protected transient LifecycleCallbackRegistry callbackRegistry

Constructor Detail

### EntityResolver

    public EntityResolver()

  Creates new EntityResolver.

### EntityResolver

    public EntityResolver(Collection dataMaps)

  Creates new EntityResolver that indexes a collection of DataMaps.

Method Detail

### getCallbackRegistry

    public LifecycleCallbackRegistry getCallbackRegistry()

  Returns a `LifecycleCallbackRegistry` for handling callbacks. Registry is lazily initialized on first call.

  Since:
    3.0

### getClientEntityResolver

    public EntityResolver getClientEntityResolver()

  Returns ClientEntityResolver with mapping information that only includes entities available on CWS Client Tier.

  Since:
    1.2

### getDbEntities

    public Collection getDbEntities()

  Returns all DbEntities.

  Specified by:
    `getDbEntities` in interface `MappingNamespace`

### getObjEntities

    public Collection getObjEntities()

  Description copied from interface: `MappingNamespace`
  Returns all ObjEntities in the namespace.

  Specified by:
    `getObjEntities` in interface `MappingNamespace`

### getProcedures

    public Collection getProcedures()

  Description copied from interface: `MappingNamespace`
  Returns all Procedures in the namespace.

  Specified by:
    `getProcedures` in interface `MappingNamespace`

### getQueries

    public Collection getQueries()

  Description copied from interface: `MappingNamespace`
  Returns all Queries in the namespace.

  Specified by:
    `getQueries` in interface `MappingNamespace`

### getDbEntity

    public DbEntity getDbEntity(String name)

  Description copied from interface: `MappingNamespace`
  Returns DbEntity for a given name, or null if no such DbEntity is found in the MappingNamespace.

  Specified by:
    `getDbEntity` in interface `MappingNamespace`

### getObjEntity

    public ObjEntity getObjEntity(String name)

  Description copied from interface: `MappingNamespace`
  Returns ObjEntity for a given name, or null if no such ObjEntity is found in the MappingNamespace.

  Specified by:
    `getObjEntity` in interface `MappingNamespace`

### getProcedure

    public Procedure getProcedure(String name)

  Description copied from interface: `MappingNamespace`
  Returns Procedure for a given name, or null if no such Procedure is found in the MappingNamespace.

  Specified by:
    `getProcedure` in interface `MappingNamespace`

### getQuery

    public Query getQuery(String name)

  Description copied from interface: `MappingNamespace`
  Returns Query for a given name, or null if no such Query is found in the MappingNamespace.

  Specified by:
    `getQuery` in interface `MappingNamespace`

### getEmbeddable

    public Embeddable getEmbeddable(String className)

  Description copied from interface: `MappingNamespace`
  Returns an `Embeddable` matching class name or null if such Embeddable is not mapped.

  Specified by:
    `getEmbeddable` in interface `MappingNamespace`
  Since:
    3.0

### getEntityListener

    public EntityListener getEntityListener(String className)

  Description copied from interface: `MappingNamespace`
  Returns an `EntityListener` matching class name or null if such EntityListener is not mapped.

  Specified by:
    `getEntityListener` in interface `MappingNamespace`
  Since:
    3.0

### getClassDescriptor

    public ClassDescriptor getClassDescriptor(String entityName)

  Returns ClassDescriptor for the ObjEntity matching the name. Returns null if no matching entity exists.

  Since:
    1.2

### addDataMap

    public void addDataMap(DataMap map)

### clearCache

    public void clearCache()

  Removes all entity mappings from the cache. Cache can be rebuilt either explicitly by calling `constructCache`, or on demand by calling any of the `lookup...` methods.

### constructCache

    protected void constructCache()

  Creates caches of DbEntities by ObjEntity, DataObject class, and ObjEntity name using internal list of maps.

### getDataMap

    public DataMap getDataMap(String mapName)

  Returns a DataMap matching the name.

### setDataMaps

    public void setDataMaps(Collection maps)

### getDataMaps

    public Collection getDataMaps()

  Returns an unmodifiable collection of DataMaps.

### lookupDbEntity

    public DbEntity lookupDbEntity(Class aClass)

  Deprecated. since 3.0 - lookup DbEntity via ObjEntity instead.

  Looks in the DataMap's that this object was created with for the DbEntity that services the specified class

  Returns:
    the required DbEntity, or null if none matches the specifier

### lookupDbEntity

    public DbEntity lookupDbEntity(Persistent dataObject)

  Deprecated. since 3.0 - lookup DbEntity via ObjEntity instead.

  Looks in the DataMap's that this object was created with for the DbEntity that services the specified data Object

  Returns:
    the required DbEntity, or null if none matches the specifier

### lookupInheritanceTree

    public EntityInheritanceTree lookupInheritanceTree(ObjEntity entity)

  Returns EntityInheritanceTree representing inheritance hierarchy that starts with a given ObjEntity as root, and includes all its subentities. If ObjEntity has no known subentities, null is returned.

### lookupObjEntity

    public ObjEntity lookupObjEntity(Class aClass)

  Looks in the DataMap's that this object was created with for the ObjEntity that maps to the services the specified class

  Returns:
    the required ObjEntity or null if there is none that matches the specifier

### lookupObjEntity

    public ObjEntity lookupObjEntity(Object object)

  Looks in the DataMap's that this object was created with for the ObjEntity that services the specified data Object

  Returns:
    the required ObjEntity, or null if none matches the specifier

### lookupObjEntity

    public ObjEntity lookupObjEntity(String entityName)

  Deprecated. since 3.0 - use getObjEntity() instead.

  Looks in the DataMap's that this object was created with for the ObjEntity that maps to the services the class with the given name

  Returns:
    the required ObjEntity or null if there is none that matches the specifier

### lookupProcedure

    public Procedure lookupProcedure(Query q)

### lookupProcedure

    public Procedure lookupProcedure(String procedureName)

### lookupQuery

    public Query lookupQuery(String name)

  Returns a named query or null if no query exists for a given name.

### removeDataMap

    public void removeDataMap(DataMap map)

### isIndexedByClass

    public boolean isIndexedByClass()

### setIndexedByClass

    public void setIndexedByClass(boolean b)

### classKey

    protected String classKey(String className)

  Generates a map key for the object class.

  Since:
    3.0

### _lookupDbEntity

    protected DbEntity _lookupDbEntity(Object object)

  Internal usage only - provides the type-unsafe implementation which services the four typesafe public lookupDbEntity methods Looks in the DataMap's that this object was created with for the ObjEntity that maps to the specified object. Object may be a Entity name, ObjEntity, DataObject class (Class object for a class which implements the DataObject interface), or a DataObject instance itself

  Returns:
    the required DbEntity, or null if none matches the specifier

### _lookupObjEntity

    protected ObjEntity _lookupObjEntity(String key)

  Internal usage only - provides the type-unsafe implementation which services the three typesafe public lookupObjEntity methods Looks in the DataMap's that this object was created with for the ObjEntity that maps to the specified object. Object may be a Entity name, DataObject instance or DataObject class (Class object for a class which implements the DataObject interface)

  Returns:
    the required ObjEntity or null if there is none that matches the specifier

### getClassDescriptorMap

    public ClassDescriptorMap getClassDescriptorMap()

  Returns an object that compiles and stores `ClassDescriptor` instances for all entities.

  Since:
    3.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2007 Apache Cayenne. All Rights Reserved.